unit DemoProgMainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,UCCompressor,
  Menus, ComCtrls, ExtCtrls, StdCtrls;

type
  TDemoProgMainForm = class(TForm)
    ListView1: TListView;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Actions1: TMenuItem;
    Extract1: TMenuItem;
    Add1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Splitter1: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Open1Click(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Extract1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure CompressItemsUpdate(Sender: TObject); //when all the items are loadded
    procedure UcOnMessage(Sender : TObject; ErrCode: Integer; Msg : String);
  end;

var
  DemoProgMainForm: TDemoProgMainForm;
  compress: TUCCompressor;

implementation

uses UcCompressorMisc;

{$R *.DFM}

procedure TDemoProgMainForm.FormCreate(Sender: TObject);
begin
     compress := TUCCompressor.Create(Self);
     compress.OnFileContentsUpdate := CompressItemsUpdate;
     compress.OnMessage := UcOnMessage;
end;

procedure TDemoProgMainForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     compress.destroy;
end;

procedure TDemoProgMainForm.Open1Click(Sender: TObject);
begin
     //compress.Filename := OpenDialog.Filename;
     compress.Filename := 'c:\lzb.lfb';
     Compress.List;
end;
//quando a lista ta cheia
procedure TDemoProgMainForm.CompressItemsUpdate(Sender: TObject);
var i: integer;
    ListItem: TListItem;
begin
     ListView1.Items.beginupdate;
     listview1.items.clear;
     for i := 0 to Compress.FileContents.Count-1 do
     begin
          ListItem := ListView1.Items.Add;
          ListItem.Caption := TFileLocalHeader(Compress.FileContents.Items[i]^).Filename;
          ListItem.SubItems.Add(FormatDateTime('yyyy/mm/dd, hh:mm:ss',FileDateToDateTime(TFileLocalHeader(Compress.FileContents.Items[i]^).DataTime)));
          ListItem.SubItems.Add(Inttostr(TFileLocalHeader(Compress.FileContents.Items[i]^).OriSize));
          ListItem.SubItems.Add(inttostr(TFileLocalHeader(Compress.FileContents.Items[i]^).CompressSize));
          ListItem.SubItems.Add(inttohex(TFileLocalHeader(Compress.FileContents.Items[i]^).Crc,8));
     end;
     ListView1.items.endupdate;
end;

procedure TDemoProgMainForm.UcOnMessage(Sender : TObject; ErrCode: Integer; Msg : String);
begin
     case ErrCode of
          CRC_ERROR:         Memo1.Lines.Add(Format('Crc Error, on file: %s',[Msg]));
          NOT_VALID_ARCHIVE: Memo1.Lines.Add(Format('Not a valid archive %s',[Msg]));
          NOT_VALID_COMPM:   Memo1.Lines.Add(Format('Don''t know how to handle %s compression',[Msg]))
     end;

end;

procedure TDemoProgMainForm.Add1Click(Sender: TObject);
begin
     if OpenDialog1.Execute then
        begin
             Caption := 'DemoProgMainForm-Compression...';
             Compress.FilesToAdd.Assign(OpenDialog1.Files);
             Compress.CompressionRatio := 1;
             Compress.Filename :=  'c:\lzb.lfb';
             Compress.Compress;
             Caption := 'DemoProgMainForm';
        end;
end;

procedure TDemoProgMainForm.Extract1Click(Sender: TObject);
begin

     Caption := 'DemoProgMainForm-Decompression...';
     Compress.FilesToAdd.Assign(OpenDialog1.Files);
     Compress.Filename :=  'c:\lzb.lfb';
     Compress.ExtrBaseDir := ExtractFilePath(ParamStr(0))+'ExtDir';
     Compress.Extract;
     Caption := 'DemoProgMainForm';
end;

procedure TDemoProgMainForm.About1Click(Sender: TObject);
begin
     ShowMessage('TUcCompressor 0.1 Beta Demo Prog'#10#13'Copyright (c) 1999 Luis Rodrigues'#10#13'All rights reserved'#10#13'Contact: lfrodriguez@hotmail.com');
end;

procedure TDemoProgMainForm.FormShow(Sender: TObject);
begin
     ShowMessage('Hi,'#10#13'Welcome to my litle compression program, don''t expect it to work very well it''s just a of testing my component!'#10#13'Feel free to help me developing the component, when ever i have i will improve this prog.'#10#13'that''s all folks... :)');
end;

procedure TDemoProgMainForm.Exit1Click(Sender: TObject);
begin
     close;
end;

end.
