{
--main Header:
  : array[0..3] of char = 'LFB'$255

  2       size of filecomment max = 64K = 65535 bytes
  X       file comment

--file header:
  bytes     what is
    4       header signature
    2       reserved(version of decompressor needed)
    2       reserved(general propose flag)
    1       os where the file was added
    1       method
    4       compressed size
    4       original size
    4       file's time stamp
    4       file crc-32
    2       filename size
    X       filename (note: the filename is null terminated)
    2       Sizeof extended header

---extended file header
    1       type of header
    X       data      x = Sizeof extended header-2-1
    2       size of next extended header

    The extended header is used to store operating system specific items:
    Atributes,etc

    And finaly the compressed data

    Size = compressed size.


Methods

0x0       =      stored   none
0x1       =      FIN      Super Fast
0x2                       faster
0x3       =      LZAri    normal
0x4       =               best
operating systems

w        =       windows 95/98
W        =       windows NT
D        =       MS-Dos, PC-Dos
U        =       Unix, Linux
2        =       OS/2

probably in the future i will release  a version of this compression for those
OS

}

{
the compressed data i composed of:
X*
  Type comp -  1-compressed 0-stored
  Size      -  size of buffer
  Buf[size] -  the actual compressed data

X = filesize div 32768

NOTE:
The stored method  is just composed by:
Buf[compressed size] -  the actual compressed data
}

{
This component is still being developed. This is just the 1st public beta.
It is full of bat concepts and mayby some logic errors

If you have any ideia how improve this component let me know.
If you want to write some source feel free to do so.

I'm still loking for the 'fast' and 'better' compression algorithms,
if you have any please let me know.

You can also help to improve the actual compression algoritms( in the files:
fin.pas and lzari.pas), i transleted it's source from c to pascal so there might
be some bugs(probably not).


Finally, if you want to help in any way or have any questions please contact me at:
lfrodriguez@hotmail.com
please use as subject:'TUcCompressor'


thanks to who ever helps me in this project


TUcCompressor is copyright 1999 by Luis Rodrigues - all rights reserved

}

unit UCCompressor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type TCompressionRat = 0..4;//(0{stored},1{SuperFast},2,3{Normal},4)
     //when the componet needs to inform the user about something
     TMessageEvent = procedure(Sender : TObject; ErrCode: Integer; Msg : String) of object;

const //error codes
     CRC_ERROR          =  1;
     NOT_VALID_ARCHIVE  =  2;
     NOT_VALID_COMPM    =  3;

type
  TUCCompressor = class(TComponent)
  private
    { Private declarations }
  protected
    FFilesToAdd: TStringList;
    FFilename: String;
    FFileContents: TList;
    FOnFileContentsUpdate: TNotifyEvent;
    FOnMessage: TMessageEvent;
    FCompressionRat: TCompressionRat;
    FExtrBaseDir: String;
    FCount: Cardinal;

    procedure SetCompressionRat(Value: TCompressionRat);
    procedure SetFilesToAdd(Value: TStringList);
    procedure SetFilename(Value: String);
    procedure SetExtrBaseDir(Value: String);
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;

    property FilesToAdd: TStringList read FFilesToAdd write SetFilesToAdd;
    property Filename: String read FFilename write SetFilename;
    property FileContents: TList read FFileContents; //we can only read the contents
    property ExtrBaseDir: String read FExtrBaseDir write SetExtrBaseDir;
    property Count: Cardinal read FCount;

    procedure List;
    procedure Compress;
    procedure Extract;
    function Test: Boolean;  //true=if archive Ok  false=if archive Bad
  published
    property CompressionRatio: TCompressionRat read FCompressionRat write SetCompressionRat;
    //events
    property OnFileContentsUpdate: TNotifyEvent read FOnFileContentsUpdate write FOnFileContentsUpdate;
    property OnMessage: TMessageEvent read FOnMEssage write FOnMessage;
  end;

procedure Register;

implementation

uses UcCompressorMisc, //misc vars and types
     Fin;              //fim compression
     //LzAri;            //lz+arithmetic compression  -!! i'm still resolving some bugs in this source
                         //it will be availeble in the next release

constructor TUcCompressor.Create(AOwner : TComponent);
begin
     inherited Create(AOwner);
     FFilesToAdd := TStringList.Create;
     FFileContents := TList.Create;
     FCompressionRat := 3;//by defalt this compress with LzAri
end;

destructor TUcCompressor.Destroy;
var i: integer;
begin
     FFilesToAdd.Free;
     //aqui apagar o conteudo da lista
     for i:= (FFileContents.Count - 1) downto 0 do
     begin
          if Assigned(FFileContents[i]) then
             // dispose of the memory pointed-to by this entry
             Dispose(PFileLocalHeader(FFileContents[i]));
          FFileContents.Delete(i); // delete the TList pointer itself
     end;
     FFileContents.Free;
     inherited Destroy;
end;

//* Properties Write methodes

procedure TUcCompressor.SetExtrBaseDir(Value: String);
begin
     //the last char of the path must be a '\'
     if Value[Length(Value)] <> '\' then
        Value := Value+'\';
     if FExtrBaseDir <> Value then
        FExtrBaseDir := Value;
end;
procedure TUcCompressor.SetFilesToAdd(Value: TStringList);
begin
     FFilesToAdd.Assign(Value);
end;

procedure TUcCompressor.SetFilename(Value: String);
begin
     if Value <> FFilename then
        FFilename := Value;
end;

procedure TUcCompressor.SetCompressionRat(Value: TCompressionRat);
begin
     if FCompressionRat <> Value then
        FCompressionRat := Value;
end;

//* compression, list and extract procedures
procedure TUcCompressor.List;
var
   PFHeader: PFileLocalHeader;

   CharIdent: array[0..3] of char;
   ComentSiz: Word;
   TmpHeader: TFileLocalHeader;
begin
     //everytime we list files, have to clean the old ones(if any)
     FFileContents.Clear;

     AssignFile(infile,Filename);
     Reset(infile,1);

     //Read the main Header
     BlockRead(infile,CharIdent,4);
     if CharIdent <> HeaderIdentfy then
        begin
             FOnMEssage(Self,NOT_VALID_ARCHIVE,FFilename);
             Exit;
        end;
     BlockRead(infile,ComentSiz,2);
     if ComentSiz > 0 then Seek(Infile,FilePos(infile)+ComentSiz);  //if there is a coment ignore it
     While not Eof(infile) do
     begin
          //create the new file header
          New(PFHeader);
          //Size of header
          BlockRead(infile,TmpHeader.HeaderSig,4);
          //reseved
          BlockRead(infile,TmpHeader.Reserved1,2);
          //reserved
          BlockRead(infile,TmpHeader.Reserved2,2);
          //operating system
          BlockRead(infile,TmpHeader.OS,1);
          //compress method
          BlockRead(infile,TmpHeader.Method,1);
          //compressed size
          BlockRead(infile, TmpHeader.CompressSize,4);
          //original size
          BlockRead(infile,TmpHeader.OriSize,4);
          //file time
          BlockRead(infile,TmpHeader.DataTime,4);
          //file unpacked crc
          BlockRead(infile,TmpHeader.Crc,4);
          //filename size
          BlockRead(infile,TmpHeader.FilenameSize,2);
          //filename
          BlockRead(infile,TmpHeader.Filename,TmpHeader.FilenameSize);
          //Extended header size
          BlockRead(infile,TmpHeader.ExtHeaderSiz,2);
          while TmpHeader.ExtHeaderSiz <> 0 do
          begin
               Seek(infile,FilePos(infile)+TmpHeader.ExtHeaderSiz-2);
               BlockRead(infile,TmpHeader.ExtHeaderSiz,2);
          end;
          //copia para o pointer
          PFHeader^ := TmpHeader;

          FFileContents.Add(PFHeader);
          //goto next local header
          Seek(infile,FilePos(infile)+TmpHeader.CompressSize);
     end;

     CloseFile(infile);
     //after we have listed all the files warn the user that we have fineshed
     if Assigned(FOnFileContentsUpdate) then
        FOnFileContentsUpdate(Self);
end;

procedure TUcCompressor.Compress;
var
   CharIdent: array[0..3] of char;
   CommentSiz: word;
   FPos,i: integer;
   S: string;
   TmpHeader: TFileLocalHeader;

   instream,outstream:UcStream;
   typecomp:byte;
   sizebuffer:word;
   BytesLeft,BytesToRead: Cardinal;
begin
     if (FCompressionRat <> 0) and (FCompressionRat <> 1) and (FCompressionRat <> 3) then //the method is no implemented yet
        begin
             FOnMEssage(Self,NOT_VALID_COMPM,IntToStr(FCompressionRat));
             Exit;
        end;
     //make the crc table
     make_crctable();
     //create the output file and open it
     AssignFile(outfile,Filename);
     Rewrite(outfile,1);

     //write the file main Header
     CharIdent := 'LFB'+#255;
     BlockWrite(Outfile,CharIdent,SizeOf(CharIdent));
     CommentSiz := 0;
     BlockWrite(outfile,CommentSiz,2);


     for i := 0 to FilesToAdd.Count-1 do
         begin
              AssignFile(infile,FilesToAdd.Strings[i]);
              FileMode := 0;  //just read
              try
                Reset(infile,1);
              except //if it was not possible to open a given file continue to the next one
                continue;
              end;

              //delete the drive from the filename
              S := FilesToAdd.Strings[i];
              if Pos(':',S) >= 1 then
                 Delete(s,1,Pos(':',S)+1);

              FPos := FilePos(outfile);

              TmpHeader.HeaderSig    := FileHeaderSig;
              TmpHeader.Reserved1    := 0;
              TmpHeader.Reserved2    := 0;
              TmpHeader.OS           := Ord('w');
              TmpHeader.Method       := $00;
              TmpHeader.CompressSize := 0;
              TmpHeader.OriSize      := FileSize(infile);
              TmpHeader.DataTime     := FileAge(FilesToAdd.Strings[i]);;
              TmpHeader.Crc          := 0;
              TmpHeader.FilenameSize := Length(S)+1;//+1 for the #0 char
              StrPCopy(TmpHeader.Filename,S);
              TmpHeader.ExtHeaderSiz := 0;

              //temp header
              WriteHeader(true,FPos,TmpHeader);

              //Compress
              CalCrc := CRC_MASK; //restore the value of CalCrc
              case FCompressionRat of
                   0: //stored
                     begin
                          TmpHeader.Method := $00;
                          TmpHeader.CompressSize :=  0;
                          BytesLeft := TmpHeader.OriSize;
                          GetMem(instream.Buffer,32768);
                          while BytesLeft <> 0 do //while there are bytes in the file to compress do this
                          begin
                               if BytesLeft >= DicSize then  //if remaining bytes more than 32K just read 32K
                                  BytesToRead := DicSize
                               else
                                   BytesToRead := BytesLeft;

                               BlockRead(Infile,instream.Buffer^[0],BytesToRead);
                               Dec(BytesLeft,BytesToRead);
                               instream.size := BytesToRead;

                               blockwrite(outfile,instream.buffer^[0],instream.size);

                               TmpHeader.CompressSize := TmpHeader.CompressSize + instream.size;
                               CalCrc := CalcBufferCrc(instream,CalCrc);
                          end;
                          FreeMem(instream.Buffer);
                     end;
                   1: //FIN
                     begin
                          TmpHeader.Method := $01;
                          FIN_InitCompression(instream,outstream);
                          //the bytes in the file that we have to read
                          BytesLeft := FileSize(InFile);
                          while BytesLeft <> 0 do //while there are bytes in the file to compress do this
                          begin
                               if BytesLeft >= DicSize then  //if remaining bytes more than 32K just read 32K
                                  BytesToRead := DicSize
                               else
                                   begin
                                        BytesToRead := BytesLeft;
                                        instream.IsFinalPiece := true;
                                   end;

                               BlockRead(Infile,instream.Buffer^[0],BytesToRead);
                               Dec(BytesLeft,BytesToRead);
                               instream.size := BytesToRead;

                               FIN_CompressStream(instream,outstream);
                               if outstream.size >= instream.size  then //didn't compress(there is no need to lost time in decompression of not compressed data)
                                  begin                               //so we save the uncompressed buffer
                                       typecomp := 0;
                                       sizebuffer := instream.size;
                                       BlockWrite(outfile,typecomp,1);
                                       blockwrite(outfile,sizebuffer,2);
                                       blockwrite(outfile,instream.buffer^[0],instream.size);
                                       TmpHeader.CompressSize := TmpHeader.CompressSize + instream.size +3; //3 from the data buffer
                                  end
                               else//did compress
                                   begin
                                        typecomp := 1; //compressed with the selected compression alg
                                        sizebuffer := outstream.size;
                                        BlockWrite(outfile,typecomp,1);
                                        blockwrite(outfile,sizebuffer,2);
                                        blockwrite(outfile,outstream.buffer^[0],outstream.size);
                                        TmpHeader.CompressSize := TmpHeader.CompressSize + outstream.size +3; //3 from the data buffer
                                   end;
                               //the only problem with this piece of code is that it adds 3 bytes to each 32k buffer,
                               //so in 1MB of compressed data the overlay is 96 bytes = 0.009% of data in the file
                               //if you have any better way PLEASE let me know
                               CalCrc := CalcBufferCrc(instream,CalCrc);
                          end;

                          FIN_FreeCompression(instream,outstream);
                     end;
                   2://don't have one yet
                     begin
                     end;
                   3://LzAri
                     begin
                           TmpHeader.Method := $03;
                           //TmpHeader.CompressSize := Compress_LzAri(FileSize(infile));
                     end;
                   4://don't have one yet
                     begin
                     end;
              end;


              TmpHeader.Crc := (CalCrc xor CRC_MASK);
              //Real header
              WriteHeader(false,FPos,TmpHeader);

              CloseFile(infile);
         end;
     //finally close the output file
     CloseFile(outfile);
end;

procedure TUcCompressor.Extract;
var
   CharIdent: array[0..3] of char;
   ComentSiz: Word;
   TmpHeader: TFileLocalHeader;

   instream,outstream:UcStream;
   BytesLeft, BytesToRead: Cardinal;
   typecomp:byte;
   sizebuffer:word;
begin
     //Make the crc table
     Make_CrcTable;

     AssignFile(infile,Filename);
     Reset(infile,1);
     //Read the main Header
     BlockRead(infile,CharIdent,4);
     if CharIdent <> HeaderIdentfy then
        begin
             FOnMEssage(Self,NOT_VALID_ARCHIVE,FFilename);
             Exit;
        end;
     BlockRead(infile,ComentSiz,2);
     if ComentSiz > 0 then Seek(Infile,FilePos(infile)+ComentSiz);
     While not Eof(infile) do
     begin
          //Size of header
          BlockRead(infile,TmpHeader.HeaderSig,4);
          //reseved
          BlockRead(infile,TmpHeader.Reserved1,2);
          //reserved
          BlockRead(infile,TmpHeader.Reserved2,2);
          //operating system
          BlockRead(infile,TmpHeader.OS,1);
          //compress method
          BlockRead(infile,TmpHeader.Method,1);
          //compressed size
          BlockRead(infile, TmpHeader.CompressSize,4);
          //original size
          BlockRead(infile,TmpHeader.OriSize,4);
          //file time
          BlockRead(infile,TmpHeader.DataTime,4);
          //file unpacked crc
          BlockRead(infile,TmpHeader.Crc,4);
          //filename size
          BlockRead(infile,TmpHeader.FilenameSize,2);
          //filename
          BlockRead(infile,TmpHeader.Filename,TmpHeader.FilenameSize);
          //Extended header size
          BlockRead(infile,TmpHeader.ExtHeaderSiz,2);
          while TmpHeader.ExtHeaderSiz <> 0 do
          begin
               Seek(infile,FilePos(infile)+TmpHeader.ExtHeaderSiz-2);
               BlockRead(infile,TmpHeader.ExtHeaderSiz,2);
          end;

          AssignFile(outfile,FExtrBaseDir+ExtractFileName(String(TmpHeader.Filename)));
          Rewrite(outfile,1);

          //extract
          CalCrc := CRC_MASK;
          Case TmpHeader.Method of
               0:
                 begin
                      GetMem(instream.buffer,32768);
                      BytesLeft := TmpHeader.CompressSize;
                      while BytesLeft <> 0 do
                      begin
                           if BytesLeft >= DicSize then  //if remaining bytes more than 32K just read 32K
                              BytesToRead := DicSize
                           else
                               BytesToRead := BytesLeft;
                           instream.Size := BytesToRead;

                           BlockRead(Infile,instream.Buffer^[0],BytesToRead);
                           //it's stored, so just output
                           blockwrite(outfile,instream.buffer^[0],instream.size);
                           //calc the crc
                           CalCrc := CalcBufferCrc(instream,CalCrc);

                           Dec(BytesLeft,BytesToRead);
                      end;
                      FreeMem(instream.buffer);
                 end;
               1:
                 begin
                      BytesLeft := TmpHeader.CompressSize;
                      FIN_InitDecompression(instream,outstream);
                      while BytesLeft <> 0 do
                      begin
                           BlockRead(infile,typecomp,1);//type of compressed data 1-TmpHeader.method or 0-store
                           BlockRead(infile,sizebuffer,2);//size of buffer
                           instream.Size := sizebuffer;

                           BlockRead(Infile,instream.Buffer^[0],sizebuffer);
                           if typecomp = 1 then
                              begin //if buffer is compressed then decompress
                                   FIN_DecompressStream(instream,outstream);
                                   blockwrite(outfile,outstream.buffer^[0],outstream.size);
                                   //calc the crc
                                   CalCrc := CalcBufferCrc(outstream,CalCrc);
                              end
                           else//if not(typecomp = 0) just output the inbuffer
                               begin
                                    blockwrite(outfile,instream.buffer^[0],instream.size);
                                    //calc the crc
                                    CalCrc := CalcBufferCrc(instream,CalCrc);
                               end;
                           BytesLeft := BytesLeft - sizebuffer - 3;
                      end;
                      FIN_FreeDecompression(instream,outstream);
                 end;
               //2:
               3: //Decompress_LzAri(TmpHeader.CompressSize,TmpHeader.OriSize); //LzAri
               //4:
          end;

          if TmpHeader.Crc <> (CalCrc xor CRC_MASK) then
             begin
                  if Assigned(FOnMessage) then
                     FOnMessage(Self,CRC_ERROR,TmpHeader.Filename);
             end;

          CloseFile(Outfile);

     end;

     CloseFile(infile);
end;

function TUcCompressor.Test: Boolean;
begin
     //I will probably write some code here in the next release
end;

procedure Register;
begin
  RegisterComponents('UcSoft', [TUCCompressor]);
end;

end.


