unit UcCompressorMisc;

interface

type
    TFileLocalHeader = record
         HeaderSig    : Cardinal;
         Reserved1    : Word;
         Reserved2    : Word;
         OS           : Byte;
         Method       : Byte;
         CompressSize : LongInt;
         OriSize      : LongInt;
         DataTime     : LongInt;
         Crc          : Cardinal;
         FilenameSize : Word;
         Filename     : array[0..255] of char;
         ExtHeaderSiz : Word;
    end;
    PFileLocalHeader = ^TFileLocalHeader;
type
    TMyBuffer = array[0..0] of byte;
    PMyBuffer = ^TMyBuffer;
    UcStream = record
          Buffer: PMyBuffer;   //bytes to compress--isto tem de ser alterado para pointer(depois)
          Size: Cardinal;        //size of buffer
          MaxSize: Cardinal;     //the maximum size of buffer eg 32768
          IsFinalPiece: Boolean; //if is the final piece of the exe
    end;

var
   infile, outfile: File;
   crctable: array[0..255] of LongInt;
   CalCrc: Cardinal;//the calculated crc ofter the compression or decompression


const
     HeaderIdentfy: array[0..3] of char = ('L','F','B',#255);
     FileHeaderSig = $4C46AAFF;       //'LF'+AAFF
     CRC_MASK = $FFFFFFFF;
     DicSize = 32768;//32k


procedure make_crctable;
procedure WriteHeader(Temp: Boolean; pos: integer; Header: TFileLocalHeader);
function CalcBufferCrc(Stream: UcStream;PreviousCrc: Cardinal): integer;

implementation

procedure make_crctable;
var
   i, j: word;
   crc,poly: Cardinal;
begin
     poly := $EDB88320;
     for i := 0 to 255 do
     begin
          crc := i;
          for j := 8 downto 1 do
              begin
                   if (crc and 1) = 1 then
                      crc := (crc shr 1) xor poly
                   else
                       crc := crc shr 1;
              end;
          crctable[i] := crc;
     end;
end;

//This function is called 2 times when compressing a file
//at the begining and at the end (the first time the compressed size an crc aren't correct
procedure WriteHeader(Temp: Boolean; pos: integer; Header: TFileLocalHeader);
var CurFPos: integer;
begin
     if not Temp then CurFPos := FilePos(Outfile);
     Seek(Outfile,Pos);

     //Size of header
     BlockWrite(Outfile,Header.HeaderSig,4);
     //reseved
     BlockWrite(Outfile,Header.Reserved1,2);
     //reserved
     BlockWrite(Outfile,Header.Reserved2,2);
     //operating system
     BlockWrite(Outfile,Header.OS,1);
     //compress method
     BlockWrite(Outfile,Header.Method,1);
     //compressed size
     BlockWrite(Outfile,Header.CompressSize,4);
     //original size
     BlockWrite(Outfile,Header.OriSize,4);
     //file time
     BlockWrite(Outfile,Header.DataTime,4);
     //file unpacked crc
     BlockWrite(Outfile,Header.Crc,4);
     //filename size
     BlockWrite(Outfile,Header.FilenameSize,2);
     //filename
     BlockWrite(Outfile,Header.Filename,Header.FilenameSize);
     //Extended header size
     BlockWrite(Outfile,Header.ExtHeaderSiz,2);
     //Go to the place we were before starting writing the header
     if not Temp then Seek(Outfile,CurFPos);
end;

function CalcBufferCrc(Stream: UcStream;PreviousCrc: Cardinal): integer;
var i:integer;
begin
     for i := 0 to Stream.Size-1 do
         PreviousCrc := crctable[( Byte(PreviousCrc) xor Byte(Stream.Buffer^[i]) ) and $ff] xor (PreviousCrc shr{CHAR_BIT}8);
     Result := PreviousCrc;
end;

end.
